/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jdbcdemo;

import java.sql.*;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author bar
 */
public class JDBCDemo {
    private static final String DB_URL="jdbc:derby://localhost:1527/jdbcdemo";
    private static int column = 3;
    private static String row = "A";
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        
        Connection con = null;
        try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            try {
                con = DriverManager.getConnection(DB_URL,"bartek","bartek");
                con.setAutoCommit(false);
                
                PreparedStatement stat = con.prepareStatement("insert into APP.GRAVES(POZICE,MIST) values(?,?)");
                
                stat.setString(1, generatePosition());
                stat.setInt(2,(new Random()).nextInt()%5+1);
                
                if(stat.executeUpdate()!=1){
                    throw new SQLException("Nepodarilo se pridat zaznam do DB:");
                }
                
                printDatabase(con);
                stat = con.prepareStatement("update APP.GRAVES set MIST=? where POZICE=?");
                stat.setInt(1,5);
                stat.setString(2, "A2");
                stat.executeUpdate();
                printDatabase(con);
                
                stat = con.prepareStatement("delete from APP.GRAVES where POZICE=?");
                stat.setString(1, "A4");
                stat.executeUpdate();
                printDatabase(con);
                con.commit();
                
            } catch (SQLException ex) {
                Logger.getLogger(JDBCDemo.class.getName()).log(Level.SEVERE, null, ex);
                try {
                    con.rollback();
                } catch (SQLException ex1) {
                    Logger.getLogger(JDBCDemo.class.getName()).log(Level.SEVERE, null, ex1);
                }
            }finally{
                if(con!=null)
                    try {
                        con.close();
                    } catch (SQLException ex) {
                        Logger.getLogger(JDBCDemo.class.getName()).log(Level.SEVERE, null, ex);
                    }
            }
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(JDBCDemo.class.getName()).log(Level.SEVERE, "Nelze nahrat ovladac od JavaDB.", ex);
            System.exit(-1);
        }
    }

    private static void printDatabase(Connection con) throws SQLException {
        PreparedStatement stat;
        //con = DriverManager.getConnection(DB_URL,"bartek","bartek");
        stat = con.prepareStatement("select * from APP.GRAVES");
        ResultSet result = stat.executeQuery();
        System.out.println("Hroby:");
        while(result.next())
        {
            String pos = result.getString("POZICE");
            int places = result.getInt("MIST");
            System.out.println(pos+": "+places);
        }
    }
    
    public static String generatePosition()
    {
        return row +""+ column++;
    }
}
